package explorviz.hpc_monitoring.filter.reduction;

import java.util.List;

import explorviz.hpc_monitoring.record.event.AbstractOperationEvent;
import explorviz.hpc_monitoring.record.trace.Trace;

public class TraceAggregationBuffer {
	private Trace accumulator;
	private final long bufferCreatedTimestamp;

	public TraceAggregationBuffer(final long bufferCreatedTimestamp) {
		this.bufferCreatedTimestamp = bufferCreatedTimestamp;
	}

	public long getBufferCreatedTimestamp() {
		return bufferCreatedTimestamp;
	}

	public Trace getAggregatedTrace() {
		return accumulator;
	}

	public void insertTrace(final Trace trace) {
		aggregate(trace);
	}

	private void aggregate(final Trace trace) {
		if (accumulator == null) {
			accumulator = trace;
		} else {
			final List<AbstractOperationEvent> aggregatedRecords = accumulator.getTraceEvents();
			final List<AbstractOperationEvent> records = trace.getTraceEvents();

			for (int i = 0; i < aggregatedRecords.size(); i++) {
				aggregatedRecords.get(i).getRuntime().merge(records.get(i).getRuntime());
			}

			accumulator.getRuntime().merge(trace.getRuntime());
		}
	}
}